
#include <iostream>
#include <vector>
#include <algorithm>
#include "Cls.h"

// display a vector
// assume there is an operator<< for elements
//
template <class T>
void display_vec(const vector<T>& v) {
    for (int i=0; i<v.size(); i++)
        cout << v[i] << " ";
    cout << "\n";
}

// given a vector, display it, 
// then sort and display it in ascending and descending order.
//
template <class T>
void run_test(vector<T>& v) {
	cout << "unsorted:" << endl;
	display_vec(v);
	sort(v.begin(), v.end());
	cout << "sorted, ascending order:" << endl;
	display_vec(v);
	reverse(v.begin(), v.end());
	cout << "sorted, descending order:" << endl;
	display_vec(v);
}

main() {

	// vector of integers
	//
	vector<int> vi;
	vi.push_back(5);
	vi.push_back(3);
	vi.push_back(8);
	vi.push_back(2);
	cout << "vector of integers -- " << endl;
	run_test(vi);

	// vector of a user-defined class
	//
	vector<Cls> vc;
	vc.push_back(15); // int implicitly converted to Cls
	vc.push_back(13);
	vc.push_back(18);
	vc.push_back(12);
	cout << "vector of Cls objects -- " << endl;
	run_test(vc);
}
